#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
const ll INF = 3*1e5;
ll values[INF];
bool on[INF];
vector<ll> helper[INF];
struct mine{ll first, second, third;};
vector<pair<ll, ll>> tree[INF*4];
vector<pair<ll, ll>> solve(vector<pair<ll, ll>> &t){
    vector<pair<ll, ll>> answer;
    for(ll i = 1; i<t.size(); i++){
        if(t[i]!=t[i-1]) answer.push_back(t[i-1]);
    }
    answer.push_back(t[t.size()-1]);
    return answer;
}
void helpbuild(ll v, ll l, ll r){
    if(l==r){
        vector<pair<ll, ll>> temp;
        for(auto element : helper[l]) temp.push_back({element, 0});
        tree[v]=solve(temp);
        return;
    }
    ll middle = (l+r)/2;
    helpbuild(v*2+1, l, middle);
    helpbuild(v*2+2, middle+1, r);
    tree[v].resize(tree[v*2+1].size()+tree[v*2+2].size());
    merge(tree[v*2+1].begin(), tree[v*2+1].end(), tree[v*2+2].begin(), tree[v*2+2].end(), tree[v].begin());
    tree[v]=solve(tree[v]);
}
pair<ll, ll> change(ll v, ll l, ll r, ll p){
    if(r<p || l>p) return {-1, -1};
    if(l==r){
        if(on[l]){
            on[l]=false;
            pair<ll, ll> temp = {values[l], 0};
            ll pos = lower_bound(tree[v].begin(), tree[v].end(), temp)-tree[v].begin();
            tree[v][pos].second--;
            return {0, values[l]};
        }
        else{
            on[l]=true;
            pair<ll, ll> temp = {values[l], 0};
            ll pos = lower_bound(tree[v].begin(), tree[v].end(), temp)-tree[v].begin();
            tree[v][pos].second++;
            return {1, values[l]};
        }
    }
    ll middle = (l+r)/2;
    pair<ll, ll> temp = change(v*2+1, l, middle, p);
    if(temp.first==-1) temp = change(v*2+2, middle+1, r, p);
    pair<ll, ll> u = {temp.second, 0};
    ll pos = lower_bound(tree[v].begin(), tree[v].end(), u)-tree[v].begin();
    if(temp.first==0) tree[v][pos].second--;
    else tree[v][pos].second++;
    return temp;
}
ll changevalue(ll v, ll l, ll r, ll p, ll value){
    if(r<p || l>p) return -1;
    if(l==r){
        on[l]=false;
        ll save = values[l];
        pair<ll, ll> temp = {values[l], 0};
        ll pos = lower_bound(tree[v].begin(), tree[v].end(), temp)-tree[v].begin();
        tree[v][pos].second--;
        values[l]=value;
        temp = {values[l], 0};
        pos = lower_bound(tree[v].begin(), tree[v].end(), temp)-tree[v].begin();
        tree[v][pos].second++;
        return save;
        
    }
    ll middle = (l+r)/2;
    ll temp = changevalue(v*2+1, l, middle, p, value);
    if(temp==-1) temp = changevalue(v*2+2, middle+1, r, p, value);
    pair<ll, ll> u = {temp, 0};
    ll pos = lower_bound(tree[v].begin(), tree[v].end(), u)-tree[v].begin();
    tree[v][pos].second--;
    u = {value, 0};
    pos = lower_bound(tree[v].begin(), tree[v].end(), u)-tree[v].begin();
    tree[v][pos].second++;
    return temp;
}
vector<pair<ll, ll>> give(ll v, ll l, ll r, ll left, ll right){
    vector<pair<ll, ll>> answer;
    if(r<left || l>right) return answer;
    if(r<=right && l>=left) return tree[v];
    vector<pair<ll, ll>> first;
    vector<pair<ll, ll>> second;
    ll middle = (l+r)/2;
    first = give(v*2+1, l, middle, left, right);
    second = give(v*2+2, middle+1, r, left, right);
    answer.resize(first.size()+second.size());
    merge(first.begin(), first.end(), second.begin(), second.end(), answer.begin());
    return answer;
}
int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, q;
    cin >> n >> q;
    for(ll i = 0; i<n; i++){ cin >> values[i]; helper[i].push_back(values[i]);}
    mine rem[q];
    for(ll i = 0; i<q; i++){
        cin >> rem[i].first;
        if(rem[i].first==2 || rem[i].first==3) cin >> rem[i].second >> rem[i].third;
        else{
            cin >> rem[i].second;
            rem[i].third=-1;
        }
        if(rem[i].first==3) helper[rem[i].second-1].push_back(rem[i].third);
    }
    for(ll i = 0; i<n; i++) sort(helper[i].begin(), helper[i].end());
    helpbuild(0, 0, n-1);
    for(ll i = 0; i<n; i++) change(0, 0, n-1, i);
    //for(auto element : tree[0]) cout << element.first << ' ' << element.second << '\n';
    //return 0;
    for(ll i = 0; i<q; i++){
        if(rem[i].first==1){
            for(ll j = 0; j<n; j++) if(values[j]==rem[i].second) change(0, 0, n-1, j);
        }
        else if(rem[i].first==2){
            vector<pair<ll, ll>> answer;
            answer=give(0, 0, n-1, rem[i].second-1, rem[i].third-1);
            set<ll> t;
            for(ll j = 0; j<answer.size(); j++) if(answer[j].second!=0) t.insert(answer[j].first);
            cout << t.size() << '\n';
        }
        else{
            rem[i].second--;
            if(!on[rem[i].second]) values[rem[i].second]=rem[i].third;
            else changevalue(0, 0, n-1, rem[i].second, rem[i].third);
        }
    }
}