def get_odd_count(n: list) -> int:
    """Get the amount of odd rows in a matrix"""

    return len([x for x in [sum(n) for n in a] if x % 2 == 1])


n, m = map(int, input().split())
c = list(map(int, input().split()))
a = [[0 for i in range(m)] for i in range(n)]
b = [0 for i in range(n)]


columns = sorted(list(map(list, enumerate(c))), key=lambda x: x[1], reverse=True)
for col in columns:

    # fill in problematic rows first
    for i, v in enumerate(b):
        if col[1] == 0:
            break
        if v == 0:
            a[i][col[0]] = 1
            b[i] = 1
            col[1] -= 1

    # fill in the rest if needed (column still has power left)
    for i, v in enumerate(b):
        if col[1] == 0:
            break
        if v == 1:
            a[i][col[0]] = 1
            b[i] = 0
            col[1] -= 1

    # print(b)


print(get_odd_count(a))
for i in range(0, n):
    for j in range(0, m):
        print(a[i][j], end=" ")
    print('\n', end='')