
def create_matrix(n, m, c):
    # Calculate total number of ones
    total_ones = sum(c)
    
    # Determine the maximum number of rows with odd sums
    if total_ones % 2 == 1:
        max_odd_rows = n
    else:
        max_odd_rows = n - 1
    
    # Initialize the matrix with zeros
    matrix = [[0] * m for _ in range(n)]
    
    # Fill the matrix column by column
    for j in range(m):
        ones_to_place = c[j]
        for i in range(ones_to_place):
            matrix[i][j] = 1
    
    # Adjust the last row if we need to make it even
    if max_odd_rows < n:
        # We need to make the last row even
        for j in range(m):
            if matrix[n-1][j] == 1:
                matrix[n-1][j] = 0
                break
    
    return max_odd_rows, matrix

# Read input
n, m = map(int, input().split())
c = list(map(int, input().split()))

# Create the matrix and get the maximum odd rows
max_odd_rows, matrix = create_matrix(n, m, c)

# Output the result
print(max_odd_rows)
for row in matrix:
    print(' '.join(map(str, row)))