#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<int> weights(n);

    for (int i = 0; i < n; i++) {
        cin >> weights[i];
    }

    int result = 0;

    while (true) {
        int weight = 0;

        for (int i = 0; i < n; i++) {
            if (weights[i] == 0) {
                continue;
            }

            if (weight + weights[i] <= 100) {
                weight += weights[i];
                weights[i] = 0;
            }

            if (weight == 100) {
                break;
            }
        }

        if (weight == 0) {
            break;
        }

        result += 1;
    }

    cout << result << "\n";

    return 0;
}
