#include <bits/stdc++.h>
using namespace std;
using ll=int;
const ll nmax=3e5+5;
ll block=450;

ll a[nmax], curans=0;

unordered_map<ll, ll>m;
set<ll>s;

struct elem{
    ll type, l, r, i, ans, in, val, x;
} q[nmax];

bool comp(elem a, elem b){
    ll ba=a.l/block;
    ll bb=b.l/block;
    if(ba!=bb) return ba < bb;
    return a.r<b.r;
}

bool endcomp(elem a, elem b){
    return a.i<b.i;
}

void add(ll in){
    if(m[a[in]]==0) ++curans;
    m[a[in]]++;
}

void cancel(ll in){
    m[a[in]]--;
    if(m[a[in]]==0) --curans;
}



int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n, nq;
    cin >> n >> nq;

    for(int i=1; i<= n; i++) cin >> a[i];

    ll type, l, r, in, val;
    for(int i=1; i<=nq; i++){
        cin >> type;
        q[i].type=type;
        q[i].i=i;
        if(type==1) cin >> q[i].x;
        if(type==2) cin >> q[i].l >> q[i].r;
        if(type==3) cin >> q[i].in >> q[i].val;
    }

    sort(q+1, q+nq+1, comp);
    add(1);

    ll curl=1, curr=1, nl, nr;

    for(int i=1; i<=nq; i++){
        nl=q[i].l;
        nr=q[i].r;
        //cout << '\n' << nl << ' ' << nr << '\n';

        while(nr > curr){
            add(++curr);
            //cout << '+' << curr << "  ";
        }
        while(nl < curl){
            add(--curl);
            //cout << '+' << curl << "  ";
        }
        while(nl > curl){
            //cout << '-' << curl << "  ";
            cancel(curl++);
        }
        while(nr < curr){
            //cout << '-' << curr << "  ";
            cancel(curr--);
        }
        //cout << curans << ' ';
        q[i].ans=curans;
    }

    sort(q+1, q+nq+1, endcomp);

    for(int i=1; i<=nq; i++) cout << q[i].ans << '\n';

    
}
