#include <iostream>
#include <vector>

using namespace std;

constexpr int M = 1e6 + 10;

vector<vector<int>> dp;
vector<vector<int>> where; // how many odd we flip
int a[M] = {};
int lg[M] = {};



int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, m;
    cin >> n >> m;

    lg[1] = 0;
    int cur = 0;
    for (int i = 2; i < M; i++) {
        if ((1 << (cur + 1)) == i) {
            cur++;
        }
        lg[i] = cur;
    }


    for (int i = 1; i <= m; i++) {
        cin >> a[i];
    }

    dp.assign(m + 2, vector<int>(n + 2, -1)); // odd
    where.assign(m + 2, vector<int>(n + 2, -1)); // odd
    for (int i = 0; i <= n; i++) {
        dp[m + 1][i] = i;
        where[m + 1][i] = 0;
    }

    int oddsp[lg[n + 1] + 1][n + 1] = {};

    for (int ii = 0; ii <= n; ii++) {
        if (ii % 2 == 1) {
            oddsp[0][ii] = ii;
        }
        else {
            oddsp[0][ii] = n + 1;
        }
    }

    for (int jj = 1; jj <= lg[n + 1]; jj++) {
        for (int ii = 0; ii <= n + 1 - (1 << jj); ii++) {
            if (dp[m + 1][oddsp[jj - 1][ii]] >
            dp[m + 1][oddsp[jj - 1][ii + (1 << (jj - 1))]]) {
                oddsp[jj][ii] = oddsp[jj - 1][ii];
            }
            else {
                oddsp[jj][ii] = oddsp[jj - 1][ii + (1 << (jj - 1))];
            }
        }
    }


    int evensp[lg[n + 1] + 1][n + 1] = {};

    for (int ii = 0; ii <= n; ii++) {
        if (ii % 2 == 0) {
            evensp[0][ii] = ii;
        }
        else {
            evensp[0][ii] = n + 1;
        }
    }

    for (int jj = 1; jj <= lg[n + 1]; jj++) {
        for (int ii = 0; ii <= n + 1 - (1 << jj); ii++) {
            if (dp[m + 1][evensp[jj - 1][ii]] >
            dp[m + 1][evensp[jj - 1][ii + (1 << (jj - 1))]]) {
                evensp[jj][ii] = evensp[jj - 1][ii];
            }
            else {
                evensp[jj][ii] = evensp[jj - 1][ii + (1 << (jj - 1))];
            }
        }
    }








    for (int i = m; i >= 1; i--) {
        for (int j = 0; j <= n; j++) {
            int l = j + a[i] - 2 * min(a[i], j);
            int r = j + a[i] - 2 * max(a[i] - n + j, 0);


            if (l > r) continue;

            int logg = lg[r - l + 1];


            if (l % 2 == 0) {

                if (dp[i + 1][evensp[logg][l]] >
                     dp[i + 1][evensp[logg][r - (1 << logg) + 1]]) {
                        dp[i][j] = dp[i + 1][evensp[logg][l]];
                        where[i][j] = (evensp[logg][l] - j - a[i]) / (-2);
                     }
                else {
                    dp[i][j] = dp[i + 1][evensp[logg][r - (1 << logg) + 1]];
                    where[i][j] = (evensp[logg][r - (1 << logg) + 1] - j - a[i]) / (-2);
                }
            }
            else {
                if (dp[i + 1][oddsp[logg][l]] >
                     dp[i + 1][oddsp[logg][r - (1 << logg) + 1]]) {
                        dp[i][j] = dp[i + 1][oddsp[logg][l]];
                        where[i][j] = (oddsp[logg][l] - j - a[i]) / (-2);
                     }
                else {
                    dp[i][j] = dp[i + 1][oddsp[logg][r - (1 << logg) + 1]];
                    where[i][j] = (oddsp[logg][r - (1 << logg) + 1] - j - a[i]) / (-2);
                }
            }

        }


        for (int ii = 0; ii <= n; ii++) {
            if (ii % 2 == 1) {
                oddsp[0][ii] = ii;
            }
            else {
                oddsp[0][ii] = n + 1;
            }
        }

        for (int jj = 1; jj <= lg[n + 1]; jj++) {
            for (int ii = 0; ii <= n + 1 - (1 << jj); ii++) {
                if (dp[i][oddsp[jj - 1][ii]] >
                dp[i][oddsp[jj - 1][ii + (1 << (jj - 1))]]) {
                    oddsp[jj][ii] = oddsp[jj - 1][ii];
                }
                else {
                    oddsp[jj][ii] = oddsp[jj - 1][ii + (1 << (jj - 1))];
                }
            }
        }



        for (int ii = 0; ii <= n; ii++) {
            if (ii % 2 == 0) {
                evensp[0][ii] = ii;
            }
            else {
                evensp[0][ii] = n + 1;
            }
        }

        for (int jj = 1; jj <= lg[n + 1]; jj++) {
            for (int ii = 0; ii <= n + 1 - (1 << jj); ii++) {
                if (dp[i][evensp[jj - 1][ii]] >
                dp[i][evensp[jj - 1][ii + (1 << (jj - 1))]]) {
                    evensp[jj][ii] = evensp[jj - 1][ii];
                }
                else {
                    evensp[jj][ii] = evensp[jj - 1][ii + (1 << (jj - 1))];
                }
            }
        }







    }


    int ans[n + 1][m + 1] = {};
    bool isodd[n + 1] = {};
    cur = 0;

    for (int i = 1; i <= m; i++) {
        int hereodd = where[i][cur];
        int hereven = a[i] - hereodd;



        for (int j = 1; j <= n; j++) {

            if (isodd[j] && hereodd > 0) {
                ans[j][i] = 1;
                hereodd--;
                isodd[j] = false;
            }
            else if (!isodd[j] && hereven > 0) {
                ans[j][i] = 1;
                hereven--;
                isodd[j] = true;
            }
        }

        cur = cur - where[i][cur] + (a[i] - where[i][cur]);
    }

    printf("%i\n", cur);

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            printf("%i ", ans[i][j]);
        }
        printf("\n");
    }








}
