#include <iostream>
#include <vector>
#include <unordered_map>
#include <unordered_set>
using namespace std;

int main() {
    int n, q;
    cin >> n >> q;
    
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    
    unordered_map<int, bool> t;
    
    auto isActive = [&](int x) -> bool {
        if (t.find(x) == t.end())
            return true;
        return t[x];
    };

    while(q--) {
        int type;
        cin >> type;
        if(type == 1) {
            int x;
            cin >> x;
            
            bool curr = (t.find(x) == t.end() ? true : t[x]);
            t[x] = !curr;
        }
        else if(type == 2) {
            int l, r;
            cin >> l >> r;
            unordered_set<int> d;
            for (int i = l - 1; i < r; i++) {
                if(isActive(a[i]))
                    d.insert(a[i]);
            }
            cout << d.size() << "\n";
        }
        else if(type == 3) {
            int x, t;
            cin >> x >> t;
            a[x - 1] = t;
        }
    }
    
    return 0;
}
