#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m, i;
    cin>>n>>m;
    int columnOnes[m];
    for(i=0;i<m;++i){
        cin>>columnOnes[i];
    }
    int matchingRows = 0;
    int emptyRows = 0;
    int genMatrix[n][m]; // [row][column]
    for (int row = 0; row<n; row++) {
        int onesInRow = 0; // could possibly replace with a bool
        // see what columns can still fit
        for (int column = 0; column<m; column++) {
            int result = columnOnes[column] > 0;
            genMatrix[row][column] = result;
            //columnOnes[column] -= result;
            onesInRow += result;
        }
        // check for our condition!!!!!!!!!!!!!!!!!! YAYYYY~~~
        if (onesInRow > 1 && onesInRow % 2 == 0) {
            //printf("ohno!!\n");
            // shift any column down if possible
            for (int column = m-1; column>=0; column--) {
                int onesLeft = columnOnes[column];
                if (onesLeft > 0 && n-row-1 >= onesLeft) {
                    genMatrix[row][column]=0;
                    //columnOnes[column]++;
                    onesInRow--;
                    break;
                }
            }
        }
        for (int column = 0; column<m; column++) {
            //printf("%d-%d\n", columnOnes[column], genMatrix[row][column]);
            columnOnes[column] -= genMatrix[row][column];
        }
        //printf("====\n");
        if (onesInRow % 2 == 1) {
            //matchingRows++;
        }
        emptyRows += onesInRow == 0;
    }
    // we may not be entirely done yet: explore awfully big rows and see if we can fit them anywhere
    for (int row = 0; row<n; row++) {
        int onesInRow = 0;
        int movableCols[m];
        int movableColCt = 0;
        // see what columns can still fit
        for (int column = 0; column<m; column++) {
            int result = genMatrix[row][column] > 0;
            //columnOnes[column] -= result;
            onesInRow += result;
            if (result == 1) {
                movableCols[movableColCt] = column;
                movableColCt++;
            }
        }
        if (onesInRow > 2 && onesInRow%2==1) {
            int maxSpace = (onesInRow+1)/2;
            int availableSpace = emptyRows/2*2;
            int willMove = availableSpace < maxSpace ? availableSpace : maxSpace;
            //printf("trying to fix row %d: need at most %d of space, available %d, moving %d\n", row+1, maxSpace, availableSpace, willMove);
            for (int i = willMove; i>0; i--) {
                genMatrix[row][movableCols[i]] = 0;
                genMatrix[n-emptyRows][movableCols[i]] = 1;
                //matchingRows++;
                emptyRows--;
            }
        }

    }
    /*for (int row = 0; row<n; row++) {
        int onesInRow = 0;
        // see what columns can still fit
        for (int column = 0; column<m; column++) {
            cout << genMatrix[row][column];
            int result = genMatrix[row][column] == 1;
            //columnOnes[column] -= result;
            onesInRow += result;
        }
        cout << endl;
        if (onesInRow > 1 && emptyRows > 0 && onesInRow%2 == 0) {
            for (int column = 0; column<m; column++) {
                if (genMatrix[row][column] == 1) {
                    genMatrix[row][column] = 0;
                    genMatrix[n-emptyRows][column] = 1;
                    //matchingRows+=2;
                    emptyRows--;
                    break;
                }
            }
        }

    }*/
    for (int row = 0; row<n; row++) {
        int onesInRow = 0;
        // see what columns can still fit
        for (int column = 0; column<m; column++) {
            int result = genMatrix[row][column] > 0;
            //columnOnes[column] -= result;
            onesInRow += result;
        }
        matchingRows += (onesInRow%2==1);
    }
    cout << matchingRows << endl;
    for (int row = 0; row < n; row++) {
        for (int column = 0; column < m; column++) {
            cout << genMatrix[row][column] << ' ';
        }
        cout << endl;
    }

    return 0;
}
