#include <bits/stdc++.h>
using namespace std;

struct Query{
    int left, right, ind_query;
    set<int> denied;
};

const int DIM = 3e5;
int arr[DIM], res[DIM], len, q;
vector<Query> query;

bool comp(Query &A, Query &B){
    return A.right < B.right || (A.right == B.right && A.left == B.left);
}

void solve_big(){
    int curr_left = 0, curr_right = 0, curr_unique = 0;
    multiset<int> curr_num;
    for (int i = 0; i < query.size(); ++i){
        int q_left = query[i].left, q_right = query[i].right;

        while (curr_right <= q_right){
            if (curr_num.find(arr[curr_right]) == curr_num.end())
                ++curr_unique;
            curr_num.insert(arr[curr_right]);
            ++curr_right;
        } 
        while (curr_left < q_left){
            if (curr_num.count(arr[curr_left]) == 1)
                --curr_unique;
            curr_num.erase(curr_num.find(arr[curr_left]));
            ++curr_left;
        }
        while (curr_left > q_left){
            --curr_left;
            if (curr_num.find(arr[curr_left]) == curr_num.end())
                ++curr_unique;
            curr_num.insert(arr[curr_left]);
        }

        res[query[i].ind_query] = curr_unique;
    }
}

void solve_small(){

}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> len >> q;
    for (int i = 0; i < len; ++i)
        cin >> arr[i];
    
    int ind_query = 0;
    set<int> curr_denied;
    for (int i = 0, type, left, right, x; i < q; ++i){
        cin >> type;
        if (type == 1){
            cin >> x;
            if (curr_denied.find(x) == curr_denied.end())
                curr_denied.insert(x);
            else
                curr_denied.erase(x);
        }
        if (type == 2){
            cin >> left >> right; --left; --right;
            query.push_back({left, right, ind_query++, curr_denied});
        }
        if (type == 3){
            cin >> x >> right; --right;
        }
    }
    sort(query.begin(), query.end(), comp);
    
    solve_big();

    for (int i = 0; i < ind_query; ++i)
        cout << res[i] << '\n';

    return 0;
}
