#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
const ll SIZ = (ll)(1e6 + 5), LONGBOI = (ll)(1e12 + 5);
mt19937 REALrandom(chrono::system_clock::to_time_t(chrono::system_clock::now()));

ll n, m, last;
ll a[SIZ];
ll firstAfter[SIZ];

void WriteAns(vector<set<ll>> &inside) {
    ll ans = 0;
    for (int i = 1; i <= n; i++) {
        if (inside[i].size() % 2 == 1) ans++;
    }
    cout << ans << endl;

    int j;
    for (int i = 1; i <= n; i++) {
        j = 1;
        for (auto x : inside[i]) {
            while (j < x) {
                cout << "0 "; j++;
            }
            cout << "1 "; j++;
        }
        while (j <= m) {
            cout << "0 "; j++;
        }
        cout << endl;
    }
}

void solve(){
    for(int i=1; i <= m; i++) firstAfter[i] = i + 1;
    vector<vector<ll>> v; v.resize(n + 5);
    for (int i = 1; i <= n; i++) v[i].resize(m + 5);
    vector<set<ll>> inside; inside.resize(n + 5);
    for (int i = 1; i <= n; i++) {
        last = 0;
        for (int j = 1; j <= m;) {
            //cout << "j = " << j << endl;
            if (a[j] > 0) {
                inside[i].insert(j);
                last = j;
                a[j]--;
            }
            while (firstAfter[j] < m && a[firstAfter[j]] == 0) firstAfter[j]++;
            j = firstAfter[j];
        }
        if (inside[i].size() > 0 && inside[i].size() % 2 == 0) {
            inside[i].erase(last);
            a[last]++;
        }
    }

    //cout << "---------------------------------------------------------------------------" << endl;
    //WriteAns(inside);
    //cout << "---------------------------------------------------------------------------" << endl;

    ll problem = 0;
    for (int i = 1; i <= m; i++) {
        if (a[i] > 0) {
            problem = i;
            break;
        }
    }

    set<ll> emptylines;
    for (int i = 1; i <= n; i++) {
        if (inside[i].size() == 0) emptylines.insert(i);
    }

    ll v1, v2, l1, l2, lastline = 1;
    while (emptylines.size() > 0 && a[problem] > 0) {
        for (auto x : emptylines) { l1 = x; break; }
        inside[l1].insert(problem);
        emptylines.erase(l1);
        a[problem]--;
    }

    while (emptylines.size() > 1) {
        l1 = LONGBOI; v1 = LONGBOI; v2 = LONGBOI;
        for (auto x : emptylines) {
            if (l1 == LONGBOI) { l1 = x; continue; }
            l2 = x; break;
        }
        emptylines.erase(l1); emptylines.erase(l2);
        //cout << "emptyline1 = " << l1 << " emptyline2 = " << l2 << endl;
        for (int i = lastline; i <= n; i++) {
            if (inside[lastline].size() < 3) {
                lastline++;
                continue;
            }
            for (auto x : inside[i]) {
                if (v1 == LONGBOI) { v1 = x; continue; }
                v2 = x; break;
            }
            break;
        }

        if (v1 != LONGBOI && v2 != LONGBOI) {
            inside[l1].insert(v1);
            inside[l2].insert(v2);
            inside[lastline].erase(v1);
            inside[lastline].erase(v2);

        }
        else break;
    }

    for (int i = 1; i <= n; i++) {
        if (a[problem] <= 0) break;
        if (inside[i].count(problem) == 0) {
            inside[i].insert(problem);
            a[problem]--;
        }
    }

    WriteAns(inside);
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> m;
    for (int i = 1; i <= m; i++) cin >> a[i];
    solve();
    return 0;
}