#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
const ll SIZ = (ll)(1e6 + 5), LONGBOI = (ll)(1e12 + 5);
mt19937 REALrandom(chrono::system_clock::to_time_t(chrono::system_clock::now()));

ll n, m;
ll a[SIZ];
ll firstAfter[SIZ];

void WriteAns(vector<set<ll>>& inside) {
    ll ans = 0;
    for (int i = 1; i <= n; i++) {
        if (inside[i].size() % 2 == 1) ans++;
    }
    cout << ans << endl;

    int j;
    for (int i = 1; i <= n; i++) {
        j = 1;
        for (auto x : inside[i]) {
            while (j < x) {
                cout << "0 "; j++;
            }
            cout << "1 "; j++;
        }
        while (j <= m) {
            cout << "0 "; j++;
        }
        cout << endl;
    }
}

//ll sa[SIZ];

void solve() {
    for (int i = 1; i <= m; i++) firstAfter[i] = i + 1;
    firstAfter[m + 1] = m + 1;
    //for (int i = 1; i <= m; i++) sa[i] = a[i];
    vector<set<ll>> inside; inside.resize(n + 5);
    ll last;
    for (int i = 1; i <= n; i++) {
        last = 0;
        for (int j = 1; j <= m;) {
            if (a[j] > 0) {
                inside[i].insert(j);
                last = j;
                a[j]--;
            }
            while (firstAfter[j] <= m && a[firstAfter[j]] == 0) firstAfter[j] = firstAfter[firstAfter[j]];
            j = firstAfter[j];
        }
        if (inside[i].size() > 0 && inside[i].size() % 2 == 0) {
            inside[i].erase(last);
            a[last]++;
        }
    }

    ll problem = 0;
    for (int i = 1; i <= m; i++) {
        if (a[i] > 0) {
            problem = i;
            break;
        }
    }
    for (int i = 1; i <= n; i++) {
        if (a[problem] <= 0) break;
        if (inside[i].count(problem) == 0) {
            inside[i].insert(problem);
            a[problem]--;
        }
    }

    set<ll> emptylines;
    for (int i = 1; i <= n; i++)
        if (inside[i].size() == 0) emptylines.insert(i);

    ll v1, v2, l1, l2, lastline = 1;

    while (emptylines.size() > 1) {
        l1 = LONGBOI; l2 = LONGBOI; v1 = LONGBOI; v2 = LONGBOI;
        for (auto x : emptylines) {
            if (l1 == LONGBOI) { l1 = x; continue; }
            l2 = x; break;
        }
        emptylines.erase(l1); emptylines.erase(l2);
        ////cout << "emptyline1 = " << l1 << " emptyline2 = " << l2 << endl;
        for (int i = lastline; i <= n; i++) {
            if (inside[i].size() != 2) continue;
            emptylines.insert(i);
            for (auto x : inside[i]) {
                if (v1 == LONGBOI) { v1 = x; continue; }
                v2 = x;
                lastline = i;
                break;
            }
            break;
        }
        if (v1 != LONGBOI && v2 != LONGBOI) {
            inside[l1].insert(v1);
            inside[l2].insert(v2);
            inside[lastline].erase(v1);
            inside[lastline].erase(v2);
        }
        else break;
    }

    lastline = 1;
    while (emptylines.size() > 1) {
        l1 = LONGBOI; l2 = LONGBOI; v1 = LONGBOI; v2 = LONGBOI;
        for (auto x : emptylines) {
            if (l1 == LONGBOI) { l1 = x; continue; }
            l2 = x; break;
        }
        emptylines.erase(l1); emptylines.erase(l2);
        ////cout << "emptyline1 = " << l1 << " emptyline2 = " << l2 << endl;
        for (int i = lastline; i <= n; i++) {
            if (inside[i].size() < 3) continue;
            for (auto x : inside[i]) {
                if (v1 == LONGBOI) { v1 = x; continue; }
                v2 = x;
                lastline = i;
                break;
            }
            break;
        }
        if (v1 != LONGBOI && v2 != LONGBOI) {
            inside[l1].insert(v1);
            inside[l2].insert(v2);
            inside[lastline].erase(v1);
            inside[lastline].erase(v2);
        }
        else break;
    }

    

    WriteAns(inside);
}

void checker(ll tests, ll PercentsPerStep, pll rn, pll rm) {
    ll k;
    pll ra;

    ll step = (tests / 100) * PercentsPerStep;
    ll currentProgress = 0;
    ll compliting = 0;
    while (tests > 0) {
        tests--;
        k = REALrandom() % (rn.second - rn.first + 1); n = k + rn.first - 1;
        if (n == 0) n = rn.second;
        k = REALrandom() % (rm.second - rm.first + 1); m = k + rm.first - 1;
        if (m == 0) m = rm.second;

        ra.first = 0; ra.second = n;

        for (int i = 1; i <= m; i++) {
            k = REALrandom() % (ra.second - ra.first); a[i] = k + ra.first;
            //////cout << "i = " << i << " a = " << a[i] << " n = " << n << endl;
            a[i] %= n;
            if (a[i] == 0) a[i] = n;
        }
        //////cout << "---------------------------------------------------------------------------" << endl;
        solve();

        compliting++;
        if (compliting % step == 0) {
            currentProgress++;
            cout << "PROGRESS : " << currentProgress * PercentsPerStep << " % " << endl;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> m;
    for (int i = 1; i <= m; i++) cin >> a[i];
    solve();

    //ll T, percents;
    //pll rn, rm;
    //cout << "T(ll), stepOfPercents(ll), rn(pll), rm(pll) : " << endl;
    //cin >> T >> percents >> rn.first >> rn.second >> rm.first >> rm.second;
    //checker(T, percents, rn, rm);
    return 0;
}