#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
const ll SIZ = (ll)(3e5 + 5), LONGBOI = (ll)(1e12 + 5);
mt19937 REALrandom(chrono::system_clock::to_time_t(chrono::system_clock::now()));

struct Question {
    ll type = 0;
    ll a = 0, b = 0;
};

ll n, m, q1, q2, q3;
vector<ll> a;
vector<Question> q;
//
// 1
//
void build(ll we, ll l, ll r, vector<set<ll>>& t) {
    if (l == r) {
        t[we].insert(a[l]);
        return;
    }

    ll m = (l + r) / 2;

    build(2 * we + 1, l, m, t);
    build(2 * we + 2, m + 1, r, t);
    for (auto x : t[2 * we + 1]) t[we].insert(x);
    for (auto x : t[2 * we + 2]) t[we].insert(x);
    return;
}

set<ll> getAns(ll we, ll l, ll r, ll tl, ll tr, vector<set<ll>>& t) {
    set<ll> ans; ans.clear();
    if (tl > r || tr < l) return ans;
    if (tl <= l && r <= tr) {
        return t[we];
    }

    ll m = (l + r) / 2;
    
    ans = getAns(2 * we + 1, l, m, tl, tr, t);
    set<ll> k2 = getAns(2 * we + 2, m + 1, r, tl, tr, t);
    for (auto x : k2) ans.insert(x);
    return ans;
}

pll change(ll we, ll l, ll r, ll x, ll nw, vector<set<ll>>& t) {
    pll ans = { LONGBOI, LONGBOI };
    if (l > x || r < x) return ans;
    if (l == r) {
        t[we].erase(a[l]); ans.second = a[l];
        a[l] = nw;
        t[we].insert(a[l]); ans.first = a[l];
        return ans;
    }

    ll m = (l + r) / 2;

    pll k = change(2 * we + 1, l, m, x, nw, t);
    pll k2 = change(2 * we + 2, m + 1, r, x, nw, t);
    if (k.first == LONGBOI && k.second == LONGBOI) swap(k, k2);
    t[we].insert(k.first);
    if (t[2 * we + 1].count(k.second) == 0 && t[2 * we + 2].count(k.second) == 0) {
        t[we].erase(k.second);
    }
    else k.second = LONGBOI;

    return k;
}

//
// 1 end
//

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> m;
    ll maxA = -LONGBOI;
    a.resize(n + 5);
    q.resize(m + 5);
    for (int i = 1; i <= n; i++) { cin >> a[i]; maxA = max(maxA, a[i]); }
    for (int i = 1; i <= m; i++) {
        cin >> q[i].type;
        if (q[i].type == 1) cin >> q[i].a;
        else cin >> q[i].a >> q[i].b;

        if (q[i].type == 1) q1++;
        else if (q[i].type == 2) q2++;
        else if (q[i].type == 3) q3++;
    }

    vector<set<ll>> t;
    t.resize(4 * (n + 5));
    build(0, 1, n, t);
    set<ll> ans;

    if (q1 == 0) {
        for (int i = 1; i <= m; i++) {
            if (q[i].type == 2) {
                ans = getAns(0, 1, n, q[i].a, q[i].b, t);
                cout << ans.size() << endl;
            }
            else {
                change(0, 1, n, q[i].a, q[i].b, t);
            }
        }
    }
    else if (q3 == 0) {
        set<ll> w;
        ll res;

        for (int i = 1; i <= m; i++) {
            if (q[i].type == 2) {
                ans = getAns(0, 1, n, q[i].a, q[i].b, t);
                res = ans.size();
                //cout << "ans = ";
                for (auto x : ans) {
                    //cout << x << " ";
                    if (w.count(x)) res--;
                } //cout << endl;
                cout << res << endl;
            }
            else {
                if (w.count(q[i].a)) w.erase(q[i].a);
                else w.insert(q[i].a);
            }
        }
    }
    else {
        set<ll> w;
        ll res;

        for (int i = 1; i <= m; i++) {
            if (q[i].type == 2) {
                ans = getAns(0, 1, n, q[i].a, q[i].b, t);
                res = ans.size();
                //cout << "ans = ";
                for (auto x : ans) {
                    //cout << x << " ";
                    if (w.count(x)) res--;
                } //cout << endl;
                cout << res << endl;
            }
            else if (q[i].type == 3) {
                change(0, 1, n, q[i].a, q[i].b, t);
            }
            else {
                if (w.count(q[i].a)) w.erase(q[i].a);
                else w.insert(q[i].a);
            }
        }
    }
    return 0;
}