n = int(input())


def solve_last_column(n, is_first_step = False) -> list[tuple]:
    """Solve the last column, while simplifying the rest"""

    if is_first_step:
        moves = [(n, n-1)]
        for i in range(1, n-1):
            moves.append((i, n))
        moves += [
            (n-1, 1),
            (n-1, n),
            (1, n)
        ]
    else:
        moves = [(n, n+1)]
        for i in range(1, n):
            moves.append((i, n))
        moves.append((n+1, n))

    return moves


moves = []
for step in range(n, 2, -1):
    if step == n:
        new_moves = solve_last_column(step, True)
    else:
        new_moves = solve_last_column(step)
    moves += new_moves

moves += [[2, 3], [1, 2], [3, 2]]

print(len(moves))
for move in moves:
    print(*move)