import itertools


def get_odd_count(n: list) -> int:
    """Get the amount of odd rows in a matrix"""

    return len([x for x in [sum(n) for n in a] if x % 2 == 1])


n, m = map(int, input().split())
c = list(map(int, input().split()))
a = [[0 for i in range(m)] for i in range(n)]

row_possibilities = []
for row in c:
    row_possibilities.append(
        set(itertools.permutations([1]*row+[0]*(n-row)))
    )
all_possibilities = [[x] for x in row_possibilities[0]]
for row in row_possibilities[1:]:
    all_possibilities = [[x+list(ip) for ip in row] for x in all_possibilities]
    all_possibilities = list(itertools.chain((all_possibilities)))

best = [[], 0]
for possibility in all_possibilities:
    print(possibility)
    odd_count = get_odd_count(possibility)
    # print(odd_count)
    if odd_count > best[1]:
        best[0] = possibility
        best[1] = odd_count

print(best)

print(best[1])
for i in range(0, m):
    for j in range(0, n):
        print(best[0][i][j], end=" ")
    print('\n', end='')