def rearrange_cubes(n):
    moves = []
    
    # Step 1: Move cubes from the last column to the first column
    for i in range(n):
        # Move the cube from column n to column 1
        moves.append((n, 1))
    
    # Step 2: Move cubes to fill the final arrangement
    for i in range(1, n + 1):
        # Move cubes of number i to their respective positions
        for j in range(n - i + 1):
            # Move from column 1 to column i
            moves.append((1, i))
        
        # Now we need to move the cubes from column i to the next column
        for j in range(i, n):
            # Move from column j+1 to column j
            moves.append((j + 1, j))
    
    # Output the number of moves and the moves themselves
    print(len(moves))
    for move in moves:
        print(move[0], move[1])

# Read input
n = int(input())
rearrange_cubes(n)