from collections import Counter
n, q = map(int, input().split())
a = list(map(int, input().split()))


toggled = set()
for _ in range(q):
    query = list(map(int, input().split()))

    type_query = query[0]
    
    if type_query == 1:  # Toggle operation
        x = query[1]
        if x in toggled:
            toggled.remove(x)  # Remove if it exists
        else:
            toggled.add(x)  # Add if it does not exist

    elif type_query == 2:  # Unique count operation
        l = query[1] - 1  # Convert to 0-based index
        r = query[2]  # r is exclusive in Python slicing
        
        # Count unique elements in the range [l, r)
        range_elements = a[l-1:r]
        count = Counter(range_elements)  # Count occurrences
        unique_count = sum(1 for key in count if key not in toggled)  # Count unique excluding toggled
        print(unique_count)

    elif type_query == 3:  # Update operation
        x, t = query[1] - 1, query[2]  # Convert to 0-based index
        a[x] = t  # Update the array
