#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    unordered_set<int> toggled; // Set to track toggled elements

    for (int i = 0; i < q; ++i) {
        int type;
        cin >> type;

        if (type == 1) { // Toggle operation
            int x;
            cin >> x;
            if (toggled.count(x)) {
                toggled.erase(x); // Remove if it exists
            } else {
                toggled.insert(x); // Add if it does not exist
            }
        } else if (type == 2) { // Count unique operation
            int l, r;
            cin >> l >> r;
            unordered_set<int> unique_elements; // Set to track unique elements in the range
            for (int j = l - 1; j < r; ++j) { // Convert to 0-based index
                if (toggled.count(a[j]) == 0) { // Check if the element is not toggled
                    unique_elements.insert(a[j]); // Add to unique set
                }
            }
            cout << unique_elements.size() << '\n'; // Output the count of unique elements
        } else if (type == 3) { // Update operation
            int x, t;
            cin >> x >> t; // Read index and new value
            a[x - 1] = t; // Update the array (convert to 0-based index)
        }
    }

    return 0;
}