use std::io;

fn main() {
    let mut input = String::new();
    
    io::stdin()
        .read_line(&mut input)
        .expect("Failed to read line");

    let _len: u32 = input.trim().parse().unwrap();

    input = String::new();
    
    io::stdin()
        .read_line(&mut input)
        .expect("Failed to read line");
        
    
    let people: Vec<u32> = input
        .trim()
        .split(" ")
        .map(|x| x.trim().parse().unwrap())
        .collect();

    let mut people_w_wt_20 = people.iter().filter(|&&x| x == 20).count();
    let mut people_w_wt_40 = people.iter().filter(|&&x| x == 40).count();
    let mut people_w_wt_60 = people.iter().filter(|&&x| x == 60).count();
    let mut people_w_wt_80 = people.iter().filter(|&&x| x == 80).count();
    let people_w_wt_100 = people.iter().filter(|&&x| x == 100).count();

    let mut ships = 0;
    if people_w_wt_20 > people_w_wt_80 {
        people_w_wt_20 -= people_w_wt_80;
        ships += people_w_wt_80;
        people_w_wt_80 = 0
    } else {
        people_w_wt_80 -= people_w_wt_20;
        ships += people_w_wt_20;
        people_w_wt_20 = 0
    }

    if people_w_wt_40 > people_w_wt_60 {
        people_w_wt_40 -= people_w_wt_60;
        ships += people_w_wt_60;
        people_w_wt_60 = 0
    } else {
        people_w_wt_60 -= people_w_wt_40;
        ships += people_w_wt_40;
        people_w_wt_40 = 0
    }

    if people_w_wt_20/2 > people_w_wt_60 {
        people_w_wt_20 -= 2*people_w_wt_60;
        ships += people_w_wt_60;
        people_w_wt_60 = 0
    } else {
        people_w_wt_60 -= people_w_wt_20/2;
        ships += people_w_wt_20/2;
        people_w_wt_20 = people_w_wt_20 % 2
    }

    if people_w_wt_40/2 > people_w_wt_20 {
        people_w_wt_40 -= 2*people_w_wt_20;
        ships += people_w_wt_20;
        people_w_wt_20 = 0
    } else {
        people_w_wt_20 -= people_w_wt_40/2;
        ships += people_w_wt_40/2;
        people_w_wt_40 %= 2
    }
    if people_w_wt_20/3 > people_w_wt_40 {
        people_w_wt_20 -= 3*people_w_wt_40;
        ships += people_w_wt_40;
        people_w_wt_40 = 0
    } else {
        people_w_wt_40 -= people_w_wt_20/3;
        ships += people_w_wt_20/3;
        people_w_wt_20 %= 3
    }

    if people_w_wt_20 > people_w_wt_60 {
        people_w_wt_20 -= people_w_wt_60;
        ships += people_w_wt_60;
        people_w_wt_60 = 0
    } else {
        people_w_wt_60 -= people_w_wt_20;
        ships += people_w_wt_20;
        people_w_wt_20 = 0
    }

    if people_w_wt_20 > people_w_wt_60 {
        people_w_wt_20 -= people_w_wt_60;
        ships += people_w_wt_60;
        people_w_wt_60 = 0
    } else {
        people_w_wt_60 -= people_w_wt_20;
        ships += people_w_wt_20;
        people_w_wt_20 = 0
    }

    if people_w_wt_20/2 > people_w_wt_40 {
        people_w_wt_20 -= 2*people_w_wt_40;
        ships += people_w_wt_40;
        people_w_wt_40 = 0
    } else {
        people_w_wt_40 -= people_w_wt_20/2;
        ships += people_w_wt_20/2;
        people_w_wt_20 %= 2
    }

    if people_w_wt_20 > people_w_wt_40 {
        people_w_wt_20 -= people_w_wt_40;
        ships += people_w_wt_40;
        people_w_wt_40 = 0
    } else {
        people_w_wt_40 -= people_w_wt_20;
        ships += people_w_wt_20;
        people_w_wt_20 = 0
    }

    ships += (people_w_wt_20+4)/5;
    ships += (people_w_wt_40+1)/2;
    ships += people_w_wt_60;
    ships += people_w_wt_80;
    ships += people_w_wt_100;

    println!("{ships}")
}
