use std::io;

fn main() {
    let mut input = String::new();

    io::stdin()
        .read_line(&mut input)
        .expect("Failed to read line");

    let [m, n]: [usize; 2] = input
        .trim()
        .split(" ")
        .map(|x| x.trim().parse().unwrap())
        .collect::<Vec<_>>()
        .try_into()
        .unwrap();

    input = String::new();

    io::stdin()
        .read_line(&mut input)
        .expect("Failed to read line");

    let mut c: Vec<u32> = input
        .trim()
        .split(" ")
        .map(|x| x.trim().parse().unwrap())
        .collect();

    let mut matrix = vec![vec![0; n]; m];

    for i in matrix.iter_mut() {
        for j in 0..n {
            if c[j] > 0 {
                c[j] -= 1;
                i[j] = 1;
            }
        }
    }

    for i in (0..m).rev() {
        if matrix[i].iter().sum::<u32>() % 2 == 1 {
            continue
        }
        'out: for j in 0..n {
            if matrix[i][j] == 1 {
                continue
            }
            for k in (0..i).rev() {
                if matrix[k][j] == 1 {
                    matrix[k][j] = 0;
                    matrix[i][j] = 1;

                    break 'out;
                }
            } 
        }
    }
    println!(
        "{}",
        matrix
            .iter()
            .filter(|x| x
                .iter()
                .filter(|&&y| y == 1)
                .count() % 2 == 1)
            .count()
    );
    for i in &matrix {
        for j in i {
            print!("{j} ")
        }
        println!("")
    }
}