use std::io;

fn main() {
    let mut input = String::new();

    io::stdin()
        .read_line(&mut input)
        .expect("Failed to read line");

    input = String::new();

    io::stdin()
        .read_line(&mut input)
        .expect("Failed to read line");

    let mut a: Vec<u32> = input
        .trim()
        .split(" ")
        .map(|x| x.trim().parse().unwrap_or(0))
        .collect();

    let mut w = Vec::new();

    loop {
        input = String::new();

        io::stdin()
            .read_line(&mut input)
            .expect("Failed to read line");

        if input.trim().is_empty() {
            break
        }

        let request: Vec<u32> = input
            .trim()
            .split(" ")
            .map(|x| x.trim().parse().unwrap_or(0))
            .collect();

        let r#type = request[0];

        match r#type {
            1 => {
                let idx = request[1];

                if w.contains(&idx) {
                    w.remove(*w.iter().find(|&&x| x == idx).unwrap_or(&0) as _);
                } else {
                    w.push(idx);
                };
            }
            2 => {
                let l: usize = *request.get(1).unwrap_or(&1) as _;
                let r: usize = *request.get(2).unwrap_or(&1) as _;

                let mut unique = Vec::new();

                let tmp = a[l-1..r]
                    .iter()
                    .filter(|x| !w.contains(x))
                    .for_each(|i| if !unique.contains(&i) {
                        unique.push(i)
                    });
                
                //println!("{:?} {unique:?} {w:?}", &a[l-1..r]);

                println!("{}", unique.len())
            }
            3 => {
                let x = request[1];
                let t = request[2];

                a[x as usize - 1] = t;
            }
            _ => {}
        } 
    }
}
