#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<int> counts(5, 0);

    for (int i = 0; i < n; i++) {
        int w;
        cin >> w;

        counts[(w / 20) - 1] += 1;
    }

    int result = counts[4];

    int type1 = min(counts[0], counts[3]);

    counts[0] -= type1;
    counts[3] -= type1;
    result += type1 + counts[3];
    counts[3] = 0;

    int type2 = min(counts[2], counts[1]);

    counts[1] -= type2;
    counts[2] -= type2;
    result += type2;

    int type3 = min(counts[2], counts[0] / 2);

    counts[0] -= type3 * 2;
    counts[2] -= type3;
    result += type3 + counts[2];
    counts[2] = 0;

    int type4 = min(counts[1] / 2, counts[0]);

    counts[0] -= type4;
    counts[1] -= type4 * 2;
    result += type4;

    if (counts[0] == 0) {
        result += (counts[1] + 1) / 2;
    } else if (counts[1] == 1) {
        result += 1;
        counts[0] = min(0, counts[0] - 3);
        counts[1] = 0;
        result += (counts[0] + 4) / 5;
        counts[0] = 0;
    } else if (counts[1] == 0) {
        result += (counts[0] + 4) / 5;
        counts[0] = 0;
    }

    cout << result << "\n";

    return 0;
}
