#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int height, width;
    cin >> height >> width;

    vector<int> row_sums(height, 0);
    vector<int> col_sums(width);

    for (int i = 0; i < width; i++) {
        cin >> col_sums[i];
    }

    vector<vector<int>> matrix(height, vector<int>(width, 0));

    vector<int> min_zeros(width);
    vector<int> max_zeros(width);

    min_zeros[0] = height - col_sums[0];
    max_zeros[0] = height - col_sums[0];
    // cout << min_zeros[0] << " " << max_zeros[0] << "\n";

    for (int j = 1; j < width; j++) {
        int prev_min = min_zeros[j - 1];
        int prev_max = max_zeros[j - 1];
        int col = col_sums[j];

        min_zeros[j] = (abs(prev_min - col) + abs(prev_max - col) - prev_max + prev_min) / 2;
        max_zeros[j] = height - ((abs(height - prev_min - col) + abs(height - prev_max - col) - prev_max + prev_min) / 2);
        // cout << min_zeros[j] << " " << max_zeros[j] << "\n";
    }

    cout << (height - min_zeros[width - 1]) << "\n";

    /*
    int odd_row_sums = 0;

    cout << odd_row_sums << "\n";

    for (int i = 0; i < height; i++) {
        for (int j = 0; j < width; j++) {
            cout << matrix[i][j] << " ";
        }

        cout << "\n";
    }
    */

    /*
    1 0 1 1
    1 1 1 0
    0 0 1 0
    0 0 1 0
    1 0 1 0
    1 0 1 0
    1 0 0 0
    1 0 0 0

    1:
    min # of overlaps = 0
    min odd = c1
    max odd = c1

    2:
    min # of overlaps = max(0, c1 + c2 - n)
    min odd = |c1 - c2|
    max odd = c1 + c2 - 2 * (min # of overlaps)

    3:


    */

    return 0;
}
