#include <bits/stdc++.h>
using namespace std;

int p20 = 0;
int p40 = 0;
int p60 = 0;
int p80 = 0;

#define MACRO_BOAT_DISTRIBUTION(o1, o2) if(o1 > 0) { \
    o1--; \
    result++; \
} else { \
    o2++; \
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, x, result = 0;
    cin>>n;
    if(n == 0) cout<<"0"<<endl;

    for(int i=0;i<n;++i){
        cin >> x;
        if(x == 20) {
            MACRO_BOAT_DISTRIBUTION(p80, p20);
        } else if(x == 40) {
            MACRO_BOAT_DISTRIBUTION(p60, p40);
        } else if(x == 60) {
            MACRO_BOAT_DISTRIBUTION(p40, p60);
        } else if(x == 80) {
            MACRO_BOAT_DISTRIBUTION(p20, p80);
        } else if(x == 100) {
            result++;
        }
    }

    // post-distribution correction algoritm
    if(p60 > 0 || p20 > 0 || p40 > 0) {
        if(p60 > 0 && p20 > 0) {
            // two p20 can be considered as one 1 p40
            int payload = ceil(p20 / (float) 2);
            if(payload <= p60) {
                p20 = 0;
            } else {
                p20 -= p60 * 2;
            }
        }

        if(p40 > 0 && p20 > 0) {
            // three p20 can be considered as one 1 p60
            int payload = ceil(p20 / (float) 3);
            if(payload <= p40) {
                p20 = 0;
                p40 -= payload;
                result += payload;
            } else {
                p20 -= p40 * 3;
                result += p40;
                p40 = 0;
            }
        }

        if(p40 > 0) {
            p40 = ceil(p40 / (float) 2);
        }

        if(p20 > 0) {
            p20 = ceil(p20 / (float) 5);
        }
    }

    result += p80;
    result += p60;
    result += p40;
    result += p20;
    cout<<result<<endl;
    return 0;
}
