#include <iostream>
#include <vector>

using namespace std;

vector<pair<int, int>> res;

void solve(int n, bool ok=false) {
    if (n == 2) {
        res.push_back({2, 3});
        res.push_back({1, 2});
        res.push_back({3, 2});
        return;
    }

    if (ok) {
        res.push_back({n, n + 1});
        for (int i = 1; i < n; i++) {
            res.push_back({i, n});
        }
        res.push_back({n + 1, n});
    }
    else {
        res.push_back({n, n - 1});
        for (int i = 1; i < n - 1; i++) {
            res.push_back({i, n});
        }
        res.push_back({n - 1, 1});
        res.push_back({n - 1, n});
        res.push_back({1, n});
    }



    solve(n - 1, true);
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n;
    cin >> n;

    solve(n);

    printf("%i\n", (int)res.size());
    for (auto op : res) {
        printf("%i %i\n", op.first, op.second);
    }


    return 0;
}
