#include <iostream>
#include <vector>

using namespace std;

constexpr int M = 1e6 + 10;

vector<vector<int>> dp;
vector<vector<int>> where; // how many odd we flip
int a[M] = {};



int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, m;
    cin >> n >> m;

    for (int i = 1; i <= m; i++) {
        cin >> a[i];
    }

    dp.assign(m + 2, vector<int>(n + 1, -1)); // odd
    where.assign(m + 2, vector<int>(n + 1, -1)); // odd
    for (int i = 0; i <= n; i++) {
        dp[m + 1][i] = i;
        where[m + 1][i] = 0;
    }


    for (int i = m; i >= 1; i--) {
        for (int j = 0; j <= n; j++) {
            for (int k = max(a[i] - n + j, 0); k <= min(a[i], j); k++) {
                    if (dp[i + 1][j - k + (a[i] - k)] > dp[i][j]) {
                        dp[i][j] = dp[i + 1][j - k + (a[i] - k)];
                        where[i][j] = k;
                    }
                }
            }
        }



    int ans[n + 1][m + 1] = {};
    bool isodd[n + 1] = {};
    int cur = 0;

    for (int i = 1; i <= m; i++) {
        int hereodd = where[i][cur];
        int hereven = a[i] - hereodd;



        for (int j = 1; j <= n; j++) {

            if (isodd[j] && hereodd > 0) {
                ans[j][i] = 1;
                hereodd--;
                isodd[j] = false;
            }
            else if (!isodd[j] && hereven > 0) {
                ans[j][i] = 1;
                hereven--;
                isodd[j] = true;
            }
        }

        cur = cur - where[i][cur] + (a[i] - where[i][cur]);
    }

    printf("%i\n", cur);

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            printf("%i ", ans[i][j]);
        }
        printf("\n");
    }








}
