#include <bits/stdc++.h>

using namespace std;

typedef int lli;

const lli BSIZE = 800;
const lli N = 7e5;

struct upd
{
    lli t,type,x,p,n;
};

struct req
{
    lli ind,l,r;
};

vector<upd> updates;
vector<lli> v;
vector<lli> v2;
set<lli> z;
map<lli,lli> new_ind;
vector<req> q;

bool cmp(req q1, req q2){
    if(q1.l/BSIZE==q2.l/BSIZE && q1.r/BSIZE==q2.r/BSIZE)return q1.ind<q2.ind;
    if (q1.l/BSIZE==q2.l/BSIZE)return q1.r<q2.r;
    return q1.l<q2.l;
}

lli l =1,r=0;

struct SIGMAK_STRUCT
{
    lli arr[N];
    lli used[N];
    lli cnt=0;
    vector<lli> a;
    void init(){
        for (int i =0;i<N;i++)used[i]=1;
        a=v;
    }

    void del1(lli &x)
    {
        if (used[x]){
            used[x]=0;
            if (arr[x])cnt--;
        }else{
            used[x]=1;
            if (arr[x])cnt++;
        }
    }

    void add_upd(upd &curr){
        if (curr.type==1){
            del1(curr.x);
        }else{
            a[curr.x] = curr.n;
            if (curr.x<=r && curr.x>=l){
                arr[curr.p]--;
                if (used[curr.p] && !arr[curr.p])cnt--;
                arr[curr.n]++;
                if (used[curr.n] && arr[curr.n]==1)cnt++;
            }
        }
    }

    void del_upd(upd &curr){
        if (curr.type==1){
            del1(curr.x);
        }else{
            a[curr.x] = curr.p;
            if (curr.x<=r && curr.x>=l){
                arr[curr.n]--;
                if (used[curr.n] && !arr[curr.n])cnt--;
                arr[curr.p]++;
                if (used[curr.p] && arr[curr.p]==1)cnt++;
            }
        }
    }

    void add(lli ind){
        arr[a[ind]]++;
        if (used[a[ind]] && arr[a[ind]]==1)cnt++;
    }
    void del(lli ind){
        arr[a[ind]]--;
        if (used[a[ind]] && !arr[a[ind]])cnt--;
    }

}ss;

vector<pair<lli,lli>> ans;

void solve()
{
    lli n,qq;
    cin >> n >> qq;
    v.resize(n+1);
    for (int i =1;i<=n;i++){
        cin >> v[i];
        z.insert(v[i]);
    }
    v2=v;
    for (lli i =1;i<=qq;i++){
        lli type;
        cin >> type;
        if (type==1){
            lli x;
            cin >> x;
            z.insert(x);
            updates.push_back({i,1,x,0,0});
        }else if (type == 2){
            lli l,r;
            cin >> l >> r;
            q.push_back({i,l,r});
        }else{
            lli x,new_val;
            cin >> x >> new_val;
            z.insert(new_val);
            updates.push_back({i,3,x,v2[x],new_val});
            v2[x]=new_val;
        }
    }
    lli cc=0;
    for (auto to : z){
        cc++;
        new_ind[to]=cc;
    }
    for (int i =1;i<=n;i++)v[i]=new_ind[v[i]];
    for (int i =0;i<updates.size();i++){
        if (updates[i].type==1)updates[i].x = new_ind[updates[i].x];
        updates[i].n = new_ind[updates[i].n];
        updates[i].p = new_ind[updates[i].p];
    }
    sort(q.begin(),q.end(),cmp);
    lli t=-1;

    ss.init();
    lli usz = updates.size();
    for(auto to : q){
        while(t+1<usz && updates[t+1].t<to.ind)ss.add_upd(updates[++t]);
        while(t>=0 && updates[t].t>to.ind)ss.del_upd(updates[t--]);

        while(r<to.r)ss.add(++r);
        while(l>to.l)ss.add(--l);
        while(r>to.r)ss.del(r--);
        while(l<to.l)ss.del(l++);
        ans.push_back({to.ind,ss.cnt});
    }
    sort(ans.begin(),ans.end());
    for (auto to : ans)cout << to.second << endl;
}


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    solve();
}
