#include <bits/stdc++.h>
using namespace std;

const int DIM = 1e6;
bool matrix[DIM];
int n, m, sum_q_1, ind_row, p = 0;
pair<int,int> q_1[DIM];

int q_full_colored;

bool &get(int i, int j){
    return matrix[i * m + j];
}
bool comp(pair<int,int> A, pair<int,int> B){
    return A.first > B.first;
}

void put_full_colored(int ind_row, int ind_col){
    for (int i = ind_row; i < n; ++i){
        get(i, q_1[ind_col].second) = 1;
        --sum_q_1;
    }
    q_1[ind_col].first = 0;
    ++q_full_colored;
}

void put_max(int ind_row, int len){
    for (int i = 0; i < len; ++i){
        get(ind_row, q_1[i].second) = 1;
        q_1[i].first--;
        --sum_q_1;
    }
    sort(q_1, q_1 + m, comp);
}

void main_cycle(){
    if (ind_row == n)
        return;
    if (sum_q_1 <= n - ind_row && q_full_colored % 2 == 0)
        return;

    if (q_1[0].first == n - ind_row){
        int i = 0;
        while (q_1[i].first == n - ind_row){
            put_full_colored(ind_row, i);
            ++i;
        }
    }
    if (q_full_colored % 2 == 0)
        p = 0;
    else
        p = 1;

    int i = 0 + p;
    int len_max = -1 + p;
    while(q_1[i].first != 0 && i < m){
        i += 2;
        len_max += 2;
    }
    

    if (sum_q_1 - len_max < n - ind_row - 1){
        put_max(ind_row, sum_q_1 - (n - ind_row++));
        return;
    }

    put_max(ind_row, len_max);

    ++ind_row;
    main_cycle();
}

void put_the_rest(int ind_row){
    for (int i = 0; i < m; ++i)
        if (ind_row < n)
            for (int j = 0; j < q_1[i].first; ++j){
                get(ind_row++, q_1[i].second) = 1;
                if (ind_row >= n)
                    return;
            }
}

int calc_res(){
    int res = 0, curr_q_1;
    for (int i = 0; i < n; ++i){
        curr_q_1 = 0;
        for (int j = 0; j < m; ++j)
            curr_q_1 += get(i, j);
        if (curr_q_1 % 2 != 0)
            ++res;
    }
    return res;
}

void output_matrix(){
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j)
            cout << get(i, j) << ' ';
        cout << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> m;
    for (int i = 0; i < m; ++i){
        cin >> q_1[i].first;
        q_1[i].second = i;
        sum_q_1 += q_1[i].first;
    }
    if (sum_q_1 > n){
        sort(q_1, q_1 + m, comp);
        if (q_1[0].first == n - ind_row){
            int i = 0;
            while (q_1[i].first == n - ind_row){
                put_full_colored(ind_row, i);
                ++i;
            }
        }
    
        if (q_full_colored % 2 == 0)
            p = 0;
        else
            p = 1;
        main_cycle();
    }

    put_the_rest(ind_row);

    cout << calc_res() << '\n';
    output_matrix();

    return 0;
}
