//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

//#pragma GCC target("avx2")

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a,b) a=max(a,b)
#define chmyin(a,b) a=min(a,b)

#define SZ 105
#define BLOCK_SIZE 548

void cpu_wait(ll s){
    auto tm = chrono::system_clock::now();
    while (chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now()-tm).count()<s){}
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n,m;
    ll a,b,c,d,e,f,g,q;
    cin>>n>>q;
    vector<bitset<SZ>> blocks((n+BLOCK_SIZE-1)/BLOCK_SIZE, 0);
    bitset<SZ> mask;
    for (ll i=0;i<SZ;i++){
        mask[i]=1;
    }
    vector<ll> arr(n);
    for (ll i=0;i<n;i++){
            cin>>arr[i];
            blocks[i/BLOCK_SIZE][arr[i]]=1;
    }
    while (q--){
        cin>>a;
        if (a==3){
            cin>>b>>c;
            --b;
            arr[b]=c;
            ll blck = b/BLOCK_SIZE;
            blocks[blck]=0;
            for (ll i=blck*BLOCK_SIZE;i<min(n,(blck+1)*BLOCK_SIZE);i++){
                blocks[blck][arr[i]]=1;
            }
        }else if (a==1){
            cin>>b;
            cout<<mask<<nl;
        }else {
            cin>>b>>c;
            --b;
            --c;
            bitset<SZ> ans;
            ll blck_beg=(b+BLOCK_SIZE-1)/BLOCK_SIZE;
            ll blck_end=c/BLOCK_SIZE;
            for (ll i=blck_beg;i<=blck_end;i++){
                ans|=blocks[i];
            }
            for (ll i=b;i<min(blck_beg*BLOCK_SIZE,c+1);i++){
                ans[arr[i]]=1;
            }
            for (ll i=blck_end*BLOCK_SIZE+1;i<=c;i++){
                ans[arr[i]]=1;
            }
            ans&=mask;
            cout<<ans.count()<<nl;
        }
    }
}
