#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#pragma GCC target("avx2")

#define ll int
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a,b) a=max(a,b)
#define chmyin(a,b) a=min(a,b)

#define SZ 100000
#define BLOCK_SIZE 5480

void cpu_wait(ll s){
    auto tm = chrono::system_clock::now();
    while (chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now()-tm).count()<s){}
}

vector<ll> vertices;
void update(ll v, ll l, ll r, ll ind){
    if (l==r){
        vertices[v]=1-vertices[v];
        return;
    }
    ll m = (l+r)/2;
    if (ind<=m){
        update(v*2,l,m,ind);
    }else {
        update(v*2+1,m+1,r,ind);
    }
    vertices[v]=vertices[v*2]+vertices[v*2+1];
}

ll get(ll v, ll l, ll r, ll ql, ll qr){
    if (ql>qr)return 0;
    if (l==ql && r==qr){
        return vertices[v];
    }
    ll m = (l+r)/2;
    return get(v*2,l,m,ql,min(qr,m)) + get(v*2+1,m+1,r,max(m+1,ql),qr);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n,m;
    ll a,b,c,d,e,f,g,q;
    cin>>n>>q;
    vertices.assign(4*n,0);
    unordered_map<ll,ll> compress;
    unordered_map<ll,ll> loc;
    vector<ll> arr(n);
    ll ind=0;
    for (ll i=0;i<n;i++){
            cin>>arr[i];
            auto it =compress.find(arr[i]);
            d=ind;
            if (it==compress.end()){
                compress[arr[i]]=ind++;
            }else{
                d = it->second;
            }
            arr[i]=d;
            loc[d]=i;
    }
    while (q--){
        cin>>a;
        if (a==1){
            cin>>b;
            auto it =compress.find(b);
            d=ind;
            if (it==compress.end()){
                continue;
            }else{
                d = it->second;
            }
            update(1,0,n-1,loc[d]);
        }else {
            cin>>b>>c;
            --b;
            --c;
            cout<<c-b+1-get(1,0,n-1,b,c)<<nl;
        }
    }
}
